import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TestCalculator extends JFrame
{
	private JTextField display;
	private JButton numButton[];
	private JButton dotButton;
	private JButton bacButton;

	private JButton addButton;
	private JButton subButton;
	private JButton mulButton;
	private JButton divButton;
	private JButton equButton;
	private JButton resetButton;

	private JPanel buttonPanel;
	private JPanel opaPanel;
	private JPanel disPanel;
	private JPanel messPanel;

	private String str;
	private String strTemp ="";
	private String strSign ="";
	private String strPrev ="";

	private int intRes =0;

    private boolean flagDot = true;
	private boolean flagAdd = true;
	private boolean flagSub = true;
	private boolean flagTemp = true;
	private boolean flagMul = true;
	private boolean flagDev = true;

	public TestCalculator()
	{
		super("Calculator");
		Container con = getContentPane();

		display = new JTextField(30);
		display.setHorizontalAlignment(display.RIGHT);
		disPanel = new JPanel();
		disPanel.setLayout(new BorderLayout(8,8));
		disPanel.add(display);
		con.add(disPanel , BorderLayout.NORTH);

        numButton = new JButton[10];
		buttonPanel =new JPanel();
		buttonPanel.setLayout(new GridLayout(5,3));
		calculatorHandle handle = new calculatorHandle();
		for(int count =9;count>=0;count--)
		{
			numButton[count] = new JButton(Integer.toString(count));
			buttonPanel.add(numButton[count]);
			numButton[count].addActionListener(handle);
		}
		dotButton= new JButton(".");
		buttonPanel.add(dotButton);
		dotButton.addActionListener(handle);

		bacButton= new JButton("BS");
		buttonPanel.add(bacButton);
		bacButton.addActionListener(handle);

		con.add(buttonPanel,BorderLayout.WEST);

		addButton = new JButton("+");
		addButton.addActionListener(handle);
		subButton = new JButton("-");
		subButton.addActionListener(handle);
		mulButton = new JButton("*");
		mulButton.addActionListener(handle);
		divButton = new JButton("/");
		divButton.addActionListener(handle);
		equButton = new JButton("=");
		equButton.addActionListener(handle);
		acButton = new JButton("AC");
		acButton.addActionListener(handle);
		acButton.setBackground(Color.GREEN);

		opaPanel =new JPanel();
		opaPanel.setLayout(new GridLayout(4,3));

		opaPanel.add(addButton);
		opaPanel.add(subButton);
		opaPanel.add(mulButton);
		opaPanel.add(divButton);
		opaPanel.add(equButton);
		opaPanel.add(resetButton);
		con.add(opaPanel,BorderLayout.EAST);
		setSize(350,350);
		setVisible(true);
	}

	private class calculatorHandle implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			//if(event.getActionCommand() == "1")
		    str = event.getActionCommand();
		    storePrev();
		    if(str == "1" || str == "2" || str == "3" || str == "4"
		                  || str == "5" || str == "6" || str == "7"
		                  || str == "8" || str == "9" || str == "0")
		       displayData();
                                       else if(str == ".")     {
		if(flagDot == true){
            		displayData();
            		flagDot = false;
			}
	else
	{
		display.setText("");
		strTemp="";
		flagDot =true;
			}
		}
	else if(str == "+")
	{
		if(flagAdd == true)
		{
		intRes = intRes + Integer.parseInt( display.getText());
		display.setText("");
		strSign ="+";
		str = "";
		strTemp = Integer.toString(intRes);
		displayData();
		strTemp="";
		System.out.println(intRes);
		    }
	   else
	    {
			str = "";
			strTemp = "YOU ENTERED TWICE + SIGN";
			displayData();
			strTemp="";
			intRes = 0;
			resetFlag();
				}
			}
 	else if(str == "-")
	{
    	if(flagSub == true)
	{
		   if(flagTemp == true){
	      intRes = Integer.parseInt( display.getText()) - intRes;
	      flagTemp = false;
		      strSign ="-";
			   }
		   else
	       intRes = intRes - Integer.parseInt( display.getText());
	   display.setText("");
		   strTemp="";
                   //flagAdd =false;
                   str = "";
		   strTemp = Integer.toString(intRes);
		   displayData();
                                   strTemp="";
		   System.out.println(intRes);
			}
		else
		{
		str = "";
		strTemp = "YOU ENTERED TWICE - SIGN";
		displayData();
		strTemp="";
		intRes = 0;
		resetFlag();
			}
		}
	else if(str == "*")
	{
		if(flagMul == true)
		{
		      if(flagTemp == true){
		 intRes = Integer.parseInt( display.getText());
		 flagTemp = false;
		 strSign ="*";
			  }
	  else
	     intRes = intRes * Integer.parseInt( display.getText());
	  display.setText("");
	  strTemp="";
	      //flagAdd =false;
                 str = "";
	          strTemp = Integer.toString(intRes);
	  displayData();
	      strTemp="";
		  System.out.println(intRes);
		    }
	  else
	  {
		 str = "";
		 strTemp = "YOU ENTERED TWICE * SIGN";
		 displayData();
		 strTemp="";
		 intRes = 0;
		 resetFlag();
		  }
		}
	else if(str == "/")
		{
	    if(flagDev == true)
		{
		   if(flagTemp == true){
		 intRes = Integer.parseInt( display.getText());
		  flagTemp = false;
		  strSign ="/";
			}
	else
		  intRes = intRes / Integer.parseInt( display.getText());
		display.setText("");
		strTemp="";
		//flagAdd =false;
		str = "";
		strTemp = Integer.toString(intRes);
		displayData();
	                strTemp="";
		   System.out.println(intRes);
			}
	else
		{
		    str = "";
		    strTemp = "YOU ENTERED TWICE / SIGN";
		    displayData();
		    strTemp="";
		    intRes = 0;
		resetFlag();
		}
	}
else if(str == "=")
	{
		if(strSign == "+")
	{
	  intRes = intRes + Integer.parseInt(display.getText());
		    }
		    else if(strSign == "-"){
			  intRes = intRes - Integer.parseInt(display.getText());
				}
		else if(strSign == "*"){
		  intRes = intRes * Integer.parseInt(display.getText());
				}
	else if(strSign == "/"){
	  intRes = intRes / Integer.parseInt(display.getText());
				}
	  strTemp = Integer.toString(intRes);
	  intRes = 0;
	  str ="";
	  strSign ="";
	  displayData();
	  strTemp = "";
	  resetFlag();
			}
	else if(str == "AC")
		{
	display.setText("");
	strTemp = "";
	strSign ="";
	intRes = 0;
	str = "";
	resetFlag();
		    }
	    else if(str == "BS")
    {
	String bsTemp = display.getText();
	char[] bsChar = bsTemp.toCharArray();
	strTemp =String.valueOf(bsChar , 0 ,bsChar.length-1);
	str = "";
	displayData();
	strTemp = "";
	}
		}
public void storePrev()
	{
		if(strPrev == str ){
		flagAdd = false;
		flagSub = false;
		flagMul = false;
		flagDev = false;
		}
		else{
	if(str == "+" || str == "-" || str == "/" || str == "*" ){
   strPrev = str;
		    }
	else{
	   strPrev = "";
	    }
	}
        }
public void displayData()
	{
strTemp = strTemp + str;
 display.setText("");
display.setText(strTemp);
    }
    public void resetFlag()
	    {
		flagDot = true;
		flagAdd = true;
		flagSub = true;
		flagTemp = true;
		flagMul = true;
		flagDev = true;
        }
	}
	public static void main(String[]args)
	{
	TestCalculator gc = new TestCalculator();
	gc.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

}