
/****************************************
 *		Muhammad khabir Ud Dulon		*
 *		03-03795-1						*
 ****************************************/



class MyString
{
	String s;

	MyString(String str)
	{
		s = str;
	}

	public char myCharAt(int index) throws IndexOutOfBoundsException
	{
		if(index >= this.myLength() || index < 0 )
			throw new IndexOutOfBoundsException("Need correct of index of Array");
		char ar[];

		ar =  s.toCharArray();

		return ar[index];
	}
	public int myCompareTo(String anotherString)
	{
		int ascii = 0;

		if(s.equals(anotherString))
			return 0;
		else
		{
			if(s.length() != anotherString.length())
				return s.length()-anotherString.length();

			else
				for(int i = 0; i<s.length(); i++)
					ascii = ascii + (s.charAt(i)-anotherString.charAt(i));

			return ascii;
		}
	}

	public int myCompareToIgnoreCase(String anotherString)
	{
		int ascii = 0;
		char c1, c2;
		String s1, s2;
		StringBuffer sb1 = new StringBuffer();
		StringBuffer sb2 = new StringBuffer();
		if(s.equalsIgnoreCase(anotherString))
			return 0;
		else
		{
			if(s.length() != anotherString.length())
				return s.length()-anotherString.length();

			else
				for(int i = 0; i<s.length(); i++)
				{
					s1 = sb1.append(s.charAt(i)).toString();
					s2 = sb2.append(anotherString.charAt(i)).toString();

					s1 = s1.toLowerCase();
					s2 = s2.toLowerCase();

					ascii = ascii + (s.charAt(0)-anotherString.charAt(0));
				}
			return ascii;
		}
	}

	public String myConcat(String str)
	{
		return s + str;
	}

	public static String myCopyValueOf(char[] data)
	{
		String str = "";
		for(int i = 0; i < data.length; i++)
			str = str + data[i];

		return str;
	}

	public boolean myStartsWith(String suffix)
	{
		if(suffix.length() == 0)
			return true;


		char ar[] = new char[s.length()];
		char br[] = new char[suffix.length()];

		ar =  s.toCharArray();
		br =  suffix.toCharArray();
		for(int i=0,j=0; j<suffix.length(); i++,j++)
			if(ar[i] != br[j])
				return false;

		return true;
	}

	public boolean myEndsWith(String suffix)
	{
		if(suffix.length() == 0)
			return true;

		char ar[] = new char[s.length()];
		char br[] = new char[suffix.length()];

		ar =  s.toCharArray();
		br =  suffix.toCharArray();
		for(int i=ar.length-1, j=br.length-1, k = 0; k<suffix.length(); i--,j--)
			if(ar[i] != br[j])
				return false;

		return true;
	}

	public boolean myEquals(String temp)
	{
			if (s.length() != temp.length())
				return false;
			for(int i=0; i<s.length(); i++)
				if(s.charAt(i) !=temp. charAt(i))
					return false;

			return true;
	}

	public boolean myEqualsIgnoreCase(String anotherString)
	{
		if (s.length() != anotherString.length())
					return false;
				for(int i=0; i<s.length(); i++)
					if(s.charAt(i) != anotherString.charAt(i) &&
					s.charAt(i)+32 != anotherString.charAt(i) &&
					s.charAt(i)-32 != anotherString.charAt(i))
						return false;

		return true;
	}

	public int myIndexOf(int ch)
	{
		char ar[];
		ar =  s.toCharArray();
		for(int i = 0; i<ar.length; i++)
			if(ar[i] == ch)
				return i;
		return -1;
	}

	public int myLastIndexOf(int ch)
	{
		char ar[];
		ar =  s.toCharArray();
		for(int i = ar.length-1; i>=0; i--)
			if(ar[i] == ch)
				return i;

		return -1;
	}

	public int myLength()
	{
		int i;
		char ar[] =  s.toCharArray();

		for( i = 0; i<ar.length; i++)
			;
		return i;
	}

	public void myGetChars(int srcBegin,int srcEnd,char[] dst,int dstBegin)
										throws IndexOutOfBoundsException
	{
		if(srcBegin < 0 || srcBegin > srcEnd || this.myLength() < srcEnd ||
				dstBegin < 0 || dstBegin+(srcEnd-srcBegin) > dst.length)
				throw new IndexOutOfBoundsException("Parameter is not Correct");
		int i;
		char temp[] = s.toCharArray();
		for( i = 0; i <dstBegin ; i++)
			dst[i] = ' ';

		for( i = 0; i <= srcEnd - srcBegin ; i++)
			dst[dstBegin++] = temp[srcBegin++];
	}


	public char[] myToCharArray()
	{
		char array[] = new char[s.length()];

		for(int i = 0; i<s.length(); i++)
			array[i] = s.charAt(i);

		return array;
	}
}

class MyStr
{
	public static void main(String args[])
	{
		MyString string = new MyString("khabirab");

		char d[] = {'a','b','c','d','e','f','g','h'};
		char a[] = new char[string.myLength()];

		System.out.println(string.myCharAt(2));
		System.out.println(string.myCompareTo("Khabir"));
		System.out.println(string.myCompareToIgnoreCase("dAbCd"));
		System.out.println(string.myConcat("aaa"));
		System.out.println(string.myCopyValueOf(d));
		System.out.println(string.myStartsWith("ibd"));
		System.out.println(string.myEndsWith("ibd"));
		System.out.println(string.myEquals("Kaabir"));
		System.out.println(string.myEqualsIgnoreCase("Kaabir"));
		System.out.println(string.myIndexOf('a'));
		System.out.println(string.myLastIndexOf('b'));
		System.out.println(string.myLength());
		System.out.println(string.myToCharArray());

		string.myGetChars(2, 5, a , -3);
		System.out.println(a);
	}
}