/****************************************
 *		Muhammad khabir Ud Dulon		*
 *		03-03795-1						*
 ****************************************/



import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class Report implements ActionListener
{
	Frame frmMain;

	Label lblName;
	Label lblId;
	Label lblDept;
	Label lblAdd;
	Label lblOs;
	Label lblSex;

	TextField txtName;
	TextField txtId;
	TextField txtDept;

	TextArea txtAdd;
	TextArea txtInfo;

	Checkbox chbLinux;
	Checkbox chbUnix;
	Checkbox chbWindows;

	CheckboxGroup cbg;

	Checkbox chbMale;
	Checkbox chbFemale;

	Button btnSave;
	Button btnClear;
	Button btnExit;

	public Report()
	{
		frmMain = new Frame("My Report");

		lblName = new Label("Name :");
		lblId 	= new Label("Id :");
		lblDept = new Label("Department :");
		lblAdd	= new Label("Address :");
		lblOs 	= new Label("OS :");
		lblSex  = new Label("Sex :");

		txtName = new TextField();
		txtId 	= new TextField();
		txtDept = new TextField();

		txtAdd	= new TextArea();
		txtInfo	= new TextArea();

		chbLinux   = new Checkbox("Linux");
		chbUnix	   = new Checkbox("Unix");
		chbWindows = new Checkbox("Windows");

		cbg 	  = new CheckboxGroup();
		chbMale   = new Checkbox("Male",cbg,false);
		chbFemale = new Checkbox("Female",cbg,false);

		btnSave = new Button("Save");
		btnClear = new Button("Clear");
		btnExit = new Button("Exit");

		frmMain.setLayout(null);
		frmMain.setBounds(80,70,550,450);

		lblName.setBounds(20,80,80,30);
		lblId.setBounds(20,120,80,30);
		lblDept.setBounds(20,160,80,30);
		lblAdd.setBounds(20,200,80,30);

		txtName.setBounds(100,80,160,30);
		txtId.setBounds(100,120,160,30);
		txtDept.setBounds(100,160,160,30);
		txtAdd.setBounds(100,200,160,90);
		txtInfo.setBounds(100,320,350,80);

		lblOs.setBounds(300,80,80,30);

		chbLinux.setBounds(340,110,80,30);
		chbUnix.setBounds(340,135,80,30);
		chbWindows.setBounds(340,160,80,30);

		lblSex.setBounds(300,200,80,30);

		chbMale.setBounds(340,225,80,30);
		chbFemale.setBounds(340,250,80,30);

		btnSave.setBounds(430,125,80,30);
		btnClear.setBounds(430,175,80,30);
		btnExit.setBounds(430,225,80,30);

		frmMain.add(lblName);
		frmMain.add(lblId);
		frmMain.add(lblDept);
		frmMain.add(lblAdd);

		frmMain.add(txtName);
		frmMain.add(txtId);
		frmMain.add(txtDept);
		frmMain.add(txtAdd);
		frmMain.add(txtInfo);

		frmMain.add(lblOs);

		frmMain.add(chbLinux);
		frmMain.add(chbUnix);
		frmMain.add(chbWindows);

		frmMain.add(lblSex);

		frmMain.add(chbMale);
		frmMain.add(chbFemale);

		frmMain.add(btnSave);
		btnSave.addActionListener(this);
		frmMain.add(btnClear);
		btnClear.addActionListener(this);
		frmMain.add(btnExit);
		btnExit.addActionListener(this);

		frmMain.show();
	}

	public void actionPerformed(ActionEvent Ae)
	{
		String msg = Ae.getActionCommand();

		if(msg.equals("Exit"))
			System.exit(0);
		if(msg.equals("Clear"))
		{
			chbUnix.setState(false);
			chbLinux.setState(false);
			chbWindows.setState(false);

			txtId.setText("");
			txtDept.setText("");
			txtAdd.setText("");
			txtName.setText("");
			txtInfo.setText("");

			chbMale.setState(false);
			chbFemale.setState(false);
		}

		if(msg.equals("Save"))
		{
			if(txtName.getText().equals("") )
			{
				txtInfo.append("Please Type you Name and other information.");
				txtInfo.append("\n");
			}
			else
			{
				try
				{
					BufferedWriter bw = new BufferedWriter(new FileWriter("H:\\test.txt", true));

					bw.write("##########################");
					bw.newLine();
					bw.write("--------------------------");
					bw.newLine();
					bw.write(lblName.getText()+" "+txtName.getText());
					bw.newLine();
					bw.write(lblId.getText()+" "+txtId.getText());
					bw.newLine();
					bw.write(lblDept.getText()+" "+txtDept.getText());
					bw.newLine();
					bw.write(lblAdd.getText()+" "+txtAdd.getText());
					bw.newLine();
					bw.newLine();
					bw.write(lblOs.getText()+" ");
					bw.newLine();
					if(chbLinux.getState())
					{
						bw.write(chbLinux.getLabel());
						bw.newLine();
					}
					if(chbUnix.getState())
					{
						bw.write(chbUnix.getLabel());
						bw.newLine();
					}
					if(chbWindows.getState())
					{
						bw.write(chbWindows.getLabel());
						bw.newLine();
					}
					bw.newLine();
					bw.write(lblSex.getText()+" ");
					bw.newLine();

					if(chbMale.getState())
					{
						bw.write(chbMale.getLabel());
						bw.newLine();
					}
					if(chbFemale.getState())
					{
						bw.write(chbFemale.getLabel());
						bw.newLine();
					}
					bw.newLine();
					bw.newLine();
					bw.close();

				}catch(IOException IOE)
				{
					System.out.println(IOE);
				}
			}
		}
	}

  	public static void main(String st[])
  	{
		new Report();
	}
}