/*
*	Class: WriteToFile
*	 Date: Feb 21, 2005
*
*	Copyright  2004-2005 Md. Tanzim Saqib. All Rights Reserved.
*	Website: www.tanzimsaqib.tk, Email: zimHere@gmail.com
*
*	Redistribution and use in source and binary forms, with or
*	without modification, are permitted provided that the following
*	conditions are met:
*
*	-Redistributions of source code must retain the above copyright
*	notice, this  list of conditions and the following disclaimer.
*
*	-Redistribution in binary form must reproduct the above copyright
*	notice, this list of conditions and the following disclaimer in
*	the documentation and/or other materials provided with the
*	distribution.
*
*	The name of the author may be used to endorse or promote products
*	derived from this software without specific prior written permission.
*
*	This software is provided "AS IS," without a warranty of any
*	kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
*	WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
*	FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
*	EXCLUDED. THE AUTHOR WILL NOT BE LIABLE FOR ANY DAMAGES OR LIABILITIES
*	SUFFERED BY LICENSEE AS A RESULT OF OR RELATING TO USE, MODIFICATION
*	OR DISTRIBUTION OF THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL
*	AUTHOR BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
*	INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES,
*	HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT
*	OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF THE AUTHOR HAS
*	BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
*
*	You acknowledge that Software is not designed, licensed or
*	intended for use in the design, construction, operation or
*	maintenance of any nuclear facility.
*
*/

import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

public class WriteToFile extends JFrame implements ActionListener
{
	public JButton btnSave;
	public JTextField txtTF;
	public static WriteToFile app;

	public WriteToFile()
	{
		super("Some Frame");
		Container con = getContentPane();
		con.setLayout(null);

		txtTF = new JTextField();
		txtTF.setFont(new Font("Tahoma", 0, 11));
		txtTF.setBounds(131, 107, 148, 19);
		con.add(txtTF);

		btnSave = new JButton("Save");
		btnSave.setFont(new Font("Tahoma", 0, 11));
		btnSave.setBounds(202, 135, 80, 21);
		btnSave.setDisplayedMnemonicIndex(0);
		btnSave.setMnemonic('S');
		btnSave.addActionListener(this);
		con.add(btnSave);

		setSize(578, 488);
		setResizable(false);
		setVisible(true);
	}

	public void actionPerformed(ActionEvent ae)
	{
		if(ae.getActionCommand().equals("Save"))
		{
			try
			{
				FileOutputStream fo = new FileOutputStream("WriteToFile.txt");
				ObjectOutputStream so = new ObjectOutputStream(fo);
				so.writeObject(app);
				so.flush();
			}
			catch (IOException e)
			{
				System.out.println(e);
		    }
		}
	}

	public static void main(String args[])
	{
		app = new WriteToFile();
		app.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
}