/****************************************
 *		Muhammad khabir Ud Dulon		*
 *		03-03795-1						*
 ****************************************/


import java.io.*;
import java.util.*;


	public interface vectOrd
    {
    	public int compareTo(Object p1, Object p2);
	}


    public class orderVector implements vectOrd
    {
    	public int compareTo(Object p1, Object p2)
        {
    	    return ((String)p1).compareTo(((String)p2));
    	}
	}

    public class read
    {
    	static String[] files = new String[100];
    	static String path = "C:\\Documents and Settings\\jacobssp\\Desktop\\IDIS\\";
   		static String nFile ="C:\\Documents and Settings\\jacobssp\\Desktop\\IDIS\\temp.csv";
    	static String thisLine = "";
    	static String[] fullText = new String[100]; //number of possible lines in your file
    	static File dir = new File("C:\\Documents and Settings\\jacobssp\\Desktop\\IDIS\\");
    	static String fName[] = new String[100];
    	static int fCounter = 0;
	    static BufferedWriter out;


        public static void getFiles()
        {
        	files = dir.list();

            for (int i=0; i<files.length; i++)
            {
            	// Get filename of file or directory

            	if (files[i].endsWith(".csv"))
            	{
                	fName[i] = files[i];
                	fCounter += 1;
            	}
			}
		}

		public static void writeToFile()
		{
            try
            {
            	out = new BufferedWriter(new FileWriter(nFile, true));

                for (int numFiles = 0; numFiles < fCounter; numFiles++)
                {
                	FileInputStream fis = new FileInputStream(path + fName[numFiles]);
                	DataInputStream myInput = new DataInputStream(fis);

                    while ( (thisLine = myInput.readLine()) != null)
                    {
                    	out.write(thisLine);
                    	out.newLine();
                	}
	            }
				out.close();
           }
           catch (IOException e) {
	           System.out.println(e);
        	}
    	}

        public static void moveFiles()
        {
        	files = dir.list();

            for (int i=0; i<files.length; i++)
            {
            	// Get filename of file or directory

                if (files[i].endsWith(".csv"))
                {
                	File file = new File(path + files[i]);
                	boolean success = file.renameTo(new File("C:\\Documents and Settings\\jacobssp\\Desktop\\IDIS\\OldFiles\\",files[i]));

                    if (!success)
                    {
                    	System.out.println(files[i] + " was not moved");
                	}
           		}
        	}

        	File file = new File("C:\\Documents and Settings\\jacobssp\\Desktop\\IDIS\\temp.csv");
	        boolean delFile = file.delete();

            if (!delFile)
            {
            	System.out.println(path + "temp.csv was not deleted");
        	}
    	}

        public static void sortVector(Vector v, vectOrd ov)
        {
           	if (v == null || ov == null)
           	{
            	System.out.println("vector and/or vector orderable is null...ERROR");
            	System.exit(0);
        	}
        	int n = v.size();
        	//begn sort routine
            for (int i = 0; i < n - 1; i++)
            {
                for (int j = i + 1; j < n; j++)
                {
                	//swapping vector elements...thus SORTIN
                	//     G
                    if (or.compareTo(v.elementAt(i),v.elementAt(j)) > 0)
                    {
                    	Object ti = v.elementAt(i);
	                    Object tj = v.elementAt(j);
	                    v.setElementAt(tj, i);
	                    v.setElementAt(ti, j);
	                }
	      		}
        	}
	        //write sorted vector to new file.
            try
            {
            	out = new BufferedWriter(new FileWriter(
            	"C:\\Documents and Settings\\jacobssp\\Desktop\\IDIS\\complied.csv", true));

                for (int vCounter = 0; vCounter < v.size(); vCounter++)
                {
                	out.write(v.elementAt(vCounter).toString());
                	out.newLine();
            	}
	          	out.close();
            	moveFiles();
            }catch (IOException ex) {
	            System.out.println(ex);
            	System.exit(0);
        	}
	   	}

        public static void getFileContents()
        {
        	int lineCounter = 0;
        	Vector ab = new Vector();
	        try
	        {
            	FileInputStream fis = new FileInputStream(nFile);
	            DataInputStream myInput = new DataInputStream(fis);

                while ( (thisLine = myInput.readLine()) != null)
                {
                	ab.addElement(thisLine);
	                lineCounter += 1;
            	}
            	if (lineCounter > 0)
            	{
                	sortVector(ab, new orderVector());
                }
                else
                {
	               	System.out.println("No contents found in file");
                	System.exit(0);
            	}
            }catch (IOException ex) {
				System.out.println(ex);
        	}
		}

        public static void main(String args[]) throws IOException
        {
        	getFiles();
        	writeToFile();
        	getFileContents();
    	}
	}