import javax.swing.*;
import javax.swing.JRootPane;
import java.awt.*;
import java.awt.event.*;
import java.sql.*;


public class Database extends JFrame implements MouseListener, ActionListener, KeyListener
{


	JLabel name;
	JLabel age;
	JLabel course;

	JTextField tname;
	JTextField tage;
	JTextField tcourse;

	JButton insert;
	JButton refresh;
	JButton next;
	JButton prev;

	ResultSet rs;
	Statement stm;
	Connection con;


	public Database()
	    {

			super( "Database Connection" );

	        Container container = getContentPane();
			container.setLayout( new FlowLayout() );



			name = new JLabel("    Name:  ");
			container.add(name);

			tname = new JTextField();
			tname.setColumns(30);
			tname.addKeyListener(this);
			container.add(tname);


			age = new JLabel("    Age:      ");
			container.add(age);

			tage = new JTextField();
			tage.setColumns(30);
			tage.addActionListener(this);
			container.add(tage);

			course = new JLabel("   Course:");
			container.add(course);


			tcourse = new JTextField();
			tcourse.setColumns(30);
			tcourse.addActionListener(this);
			container.add(tcourse);

			Icon submit = new ImageIcon("submit2.jpg");

			insert = new JButton(submit);
			insert.addMouseListener(this);



			refresh = new JButton("Refresh");
			refresh.addMouseListener(this);



			Icon previ = new ImageIcon("previous.gif");
			prev = new JButton(previ);
			prev.addMouseListener(this);


			Icon nextb = new ImageIcon("next.gif");
			next = new JButton(nextb);
			next.addMouseListener(this);

			container.add(prev);
			//prev.addActionListener(this);

			container.add(insert);
			//insert.addActionListener(this);

			container.add(next);
			//next.addActionListener(this);

			container.add(refresh);
			//refresh.addActionListener(this);

			addMouseListener(this);
			//addActionListener(this);


			setSize( 450, 300);
	        setVisible( true );
	        setResizable(false);


			setconn();


		}

		void setconn()
		{
			try
			{
					Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

					con=DriverManager.getConnection("jdbc:odbc:student","student","guest");

					stm=con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_READ_ONLY);

					rs=stm.executeQuery("select * from student");


			}
			catch(Exception e)
            {
                   System.out.println(e.getMessage());
            }


		}



		public void mouseClicked(MouseEvent e)
		{
			if(e.getSource()==insert)
				{
					String name = tname.getText();

					String age = tage.getText();

					String cse = tcourse.getText();


					try
					{
						stm.executeUpdate("INSERT INTO student values("+"'"+name+"'" +","+age+","+"'"+cse+"'"+")");
					}
					catch(Exception e2)
						 {
						    System.out.println(e2.getMessage());
           				 }

				}

			else if(e.getSource()==refresh)
				{
					tname.setText(" ");
					tage.setText(" ");
					tcourse.setText(" ");
				}

			else if(e.getSource()==prev)
				{
					try
					{

						rs.previous();

						if(rs.isFirst())
							rs.last();

						tname.setText(rs.getString("Name"));
						tage.setText(rs.getString("Age"));
						tcourse.setText(rs.getString("Course"));


					}
					catch(Exception e2)
					{
						System.out.println(e2.getMessage());
           			}

				}

			else if(e.getSource()==next)
				{
					try
					{
						rs.next();

						if(rs.isLast())
							rs.first();

						tname.setText(rs.getString("Name"));
						tage.setText(rs.getString("Age"));
						tcourse.setText(rs.getString("Course"));
					}
					catch(Exception e2)
					{
						System.out.println(e2.getMessage());
           			}
				}
		}

		public void mouseEntered(MouseEvent e)
		{
		}

		public void mouseExited(MouseEvent e)
		{
		}

		public void mousePressed(MouseEvent e)
		{
		}

		public void mouseReleased(MouseEvent e)
		{
		}

		public void actionPerformed(ActionEvent e)
		{


							if(e.getSource()==tname)
								tage.setRequestFocusEnabled(true);

							else if(e.getSource()==tage)
								tcourse.setRequestFocusEnabled(true);

							else
								{
								}




		}

		public void keyPressed(KeyEvent e)
		{
		}

		public void keyReleased(KeyEvent e)
		{

			if(e.getKeyCode()==13)
			{
				if(e.getSource()==tname)
					tage.setRequestFocusEnabled(true);

				else if(e.getSource()==tage)
					tcourse.setRequestFocusEnabled(true);

				else
					{
					}
			}


		}

		public void keyTyped(KeyEvent e)
		{

		}




		public static void main( String args[] )
		{
			Database db = new Database();

			db.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE);
		}

}
