import javax.swing.*;
import javax.swing.JRootPane;
import java.awt.*;
import java.awt.event.*;


public class MyEvent1 extends JApplet implements MouseListener,ActionListener
{
    String msg="";
    int x=0, y=0;
    JButton b;
    
    public void init()
    {
        Container c=getContentPane();
        c.setLayout(new FlowLayout());
        addMouseListener(this);
        b=new JButton("Hello");
        b.addActionListener(this);
        c.add(b);
    }
    
    public void mouseClicked(MouseEvent e)
    {
        x=10;
        y=10;
        msg="Mouse clicked";
        repaint();
    }
    
    public void mouseEntered(MouseEvent e)
    {
        x=10;
        y=10;
        msg="Mouse entered";
        repaint();
    }
    
    public void mouseExited(MouseEvent e)
    {        
    }
    
    public void mousePressed(MouseEvent e)
    {
        x=e.getX();
        y=e.getY();
        msg="Down";
        repaint();
    }
    
    public void mouseReleased(MouseEvent e)
    {
        x=e.getX();
        y=e.getY();
        msg="up";
        repaint();
    }
    
    public void actionPerformed(ActionEvent e)
    {
        msg=e.getActionCommand();
        repaint();
    }   
    
    public void paint(Graphics g)
    {
        g.drawString(msg,x,y);
    }
}
