import java.awt.*;
import java.applet.*;
public class ScrollingText extends Applet implements Runnable
{
    private Thread t;
    private String message = "I Love Java!    ";
    private boolean stopFlag;
    
    public void init()
    {
        t=null;        
    }
    
    public void start()
    {
        t = new Thread(this);
        stopFlag = false;
        t.start();        
    }
    
    public void run()
    {
        char c;        
        for( ; ; )
        {
            try{
                repaint();
                Thread.sleep(50);
                c = message.charAt(0);
                message = message.substring(1,message.length());
                message += c;
                if(stopFlag)break;
            } catch (InterruptedException exc) {}
         }
    }
    
    public void stop() 
    {
        stopFlag = true;
        t = null;
    }    
    
    public void paint(Graphics g)
    {
        Font f = new Font("Arial", Font.BOLD, 25);
        g.setFont(f);
        g.drawString(message,50,25);
        
    }    
    
    
}   
